package sun.rmi.transport.proxy;

import sun.rmi.runtime.Log;
import java.io.BufferedInputStream;
import java.net.Socket;
import java.io.IOException;
import java.net.ServerSocket;

class HttpAwareServerSocket extends ServerSocket
{
    public HttpAwareServerSocket(int port) throws IOException {
        super(port);
    }
    
    public HttpAwareServerSocket(int port, int backlog) throws IOException {
        super(port, backlog);
    }
    
    @Override
    public Socket accept() throws IOException {
        Socket accept = super.accept();
        BufferedInputStream bufferedInputStream = new BufferedInputStream(accept.getInputStream());
        RMIMasterSocketFactory.proxyLog.log(Log.BRIEF, "socket accepted (checking for POST)");
        bufferedInputStream.mark(4);
        int n = bufferedInputStream.read() == 80 && bufferedInputStream.read() == 79 && bufferedInputStream.read() == 83 && bufferedInputStream.read() == 84;
        bufferedInputStream.reset();
        if (RMIMasterSocketFactory.proxyLog.isLoggable(Log.BRIEF)) {
            RMIMasterSocketFactory.proxyLog.log(Log.BRIEF, n ? "POST found, HTTP socket returned" : "POST not found, direct socket returned");
        }
        if (!(n == 0)) {
            return new HttpReceiveSocket(accept, bufferedInputStream, null);
        }
        return new WrappedSocket(accept, bufferedInputStream, null);
    }
    
    @Override
    public String toString() {
        return "HttpAware" + super.toString();
    }
}
